IncludeScript("_charlib/weapon_list.nut")

function ConvertToCustomCharacter(player, includeScript)
{
    EntFireByHandle(player,
        "RunScriptCode",
        format("IncludeScript(`_charlib/custom_character.nut`); IncludeScript(`%s`); ConvertToCustomCharacter();", includeScript),
        -1,
        player,
        player);
}

function ClearCustomCharacter(player, roundStart = false)
{
    if (IsCustomCharacter(player))
        player.GetScriptScope().ClearCustomCharacter(roundStart);
}

function IsCustomCharacter(player, character = null)
{
    local characterName = safeget(player.GetScriptScope(), "characterName", null);
    return characterName && (!character || characterName == character);
}
GetCustomCharacter <- IsCustomCharacter;

OnGameEvent("teamplay_round_start", 0, function()
{
    foreach(player in GetClients())
        ClearCustomCharacter(player, true);
});