damageTables <- player_collection(player_collection(0));

OnGameEvent("player_hurt", 100, function(victim, params)
{
    if (!IsValidRound(false))
        return;
    local attacker = GetPlayerFromParams(params, "attacker");
    if (attacker)
        damageTables[victim.entindex()][attacker.entindex()] += params.damageamount;
    else
        attacker = victim;

    if (victim.GetHealth() <= 0)
    {
        if (attacker == victim)
        {
            local assister = GetAssister(victim, attacker);
            if (assister != victim)
                victim.AddCondEx(TF_COND_URINE, 0, assister);
        }
    }
})

OnGameEvent("player_death", 10, function(victim, params)
{
    if (!IsValidRound())
        return;
    local attacker = GetPlayerFromParams(params, "attacker");

    if (attacker && attacker != victim)
    {
        kills[attacker.entindex()]++;
        kills2[attacker.entindex()]++;
    }
});

function GetAssister(victim, attacker)
{
    local assister = victim.entindex();
    attacker = attacker.entindex();
    local damage = 20;
    foreach(iAssister, iDamage in damageTables[victim.entindex()])
    {
        local iAssisterEnt = PlayerInstanceFromIndex(iAssister);
        if (iDamage > damage && iAssister != attacker)
        {
            assister = iAssister;
            damage = iDamage;
        }
    }
    return PlayerInstanceFromIndex(assister);
}

OnGameEvent("player_spawn", 0, function(player, params)
{
    damageTables[player.entindex()] = player_collection(0);
});

AddTimer(1, 0, function()
{
    foreach(damageTable in damageTables)
        foreach(player, damage in damageTable)
            if (damage > 0)
                damageTable[player] = damage - 5;
})