info_player_teamspawns <- [];

for (local spawn = null; spawn = Entities.FindByClassname(spawn, "info_player_teamspawn");)
    info_player_teamspawns.push(spawn);

//todo optimize
OnGameEvent("player_spawn", -101, function(player, params)
{
    local target = TryFindFreeSpawn(player, 1000);
    if (!target)
        target = TryFindFreeSpawn(player, 500);
    if (target)
    {
        player.SetAbsOrigin(target.GetOrigin());
        player.SetAbsAngles(target.GetAbsAngles());
    }
});

function TryFindFreeSpawn(player, radius)
{
    local myPos = player.GetOrigin();
    local players = GetAllPlayers();
    foreach(spawnEnt in ShuffleArray(info_player_teamspawns))
    {
        local flag = true;
        local spawnEntPos = spawnEnt.GetOrigin();
        foreach (otherPlayer in players)
        {
            if (player != otherPlayer && (otherPlayer.GetOrigin() - spawnEntPos).Length() < radius)
            {
                flag = false;
                break;
            }
        }
        if (flag)
            return spawnEnt;
    }
    return null;
}