//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

IncludeScript("ffa/mercenary/_mercenary.nut");

//_post is a hack
OnSelfGameEvent("post_inventory_application_post", 10, function()
{
    if (!GetPersistentVar("disable_overlays", false))
        self.SetScriptOverlayMaterial("gungame/ui/" + GetCurrentGunGameWeapon(self).names[0] + "_to_" + GetNextGunGameWeapon(self).names[0]);
    local newWeapon = EquipWeapon(GetCurrentGunGameWeapon(self));
    if (newWeapon.GetSlot() == 2)
    {
        local crowbar = FindWeaponEntityByType(self, GetWeaponTypeByName("crowbar"));
        if (crowbar)
            crowbar.Kill();
    }
    self.Weapon_Switch(newWeapon);
});

function SwitchToNextWeapon()
{
    local wasMeleeActive = self.GetActiveWeapon();
    wasMeleeActive = wasMeleeActive && wasMeleeActive.IsValid() ? wasMeleeActive.GetSlot() == 2 : false;

    for (local i = 0; i < 10; i++)
    {
        local weaponEnt = GetPropEntityArray(self, "m_hMyWeapons", i);
        if (weaponEnt && weaponEnt.GetSlot() != 2)
        {
            weaponEnt.Kill();
            SetPropEntityArray(self, "m_hMyWeapons", null, i);
        }
    }
    local crowbar = FindWeaponEntityByType(self, GetWeaponTypeByName("crowbar"));
    if (!crowbar)
    {
        KillWeaponBySlot(self, 2);
        EquipWeapon(GetWeaponTypeByName("crowbar"));
        wasMeleeActive = false;
    }
    local newWeapon = EquipWeapon(GetCurrentGunGameWeapon(self));
    if (newWeapon.GetSlot() == 2 && crowbar)
    {
        crowbar.Kill();
        wasMeleeActive = false;
    }
    if (!wasMeleeActive)
    {
        self.Weapon_Switch(newWeapon);
        //Sometimes an old weapon prevents switch to a new weapon the same tick the old one's getting destroyed.
        //Examples being scoped-in Sniper Rifles, in-load Beggars', span-up Miniguns, etc.
        RunWithDelay(0.1, function() {
            self.Weapon_Switch(newWeapon);
        }, self)
    }
}