::info_player_teamspawns <- [];

for (local spawn = null; spawn = Entities.FindByClassname(spawn, "info_player_teamspawn");)
    info_player_teamspawns.push(spawn);

OnGameEvent("player_spawn_post", -101, function(player, params)
{
    local target = CalcSpawnScores(player);
    player.SetAbsOrigin(target);
});

::CalcSpawnScores <- function(player = null)
{
    local time = Time();
    local players = GetAlivePlayers();
    local maxScore = 0;
    local maxScoreSpawn = players[0].GetOrigin();

    printl("player= " + player);
    local myScore;
    foreach (spawnEnt in info_player_teamspawns)
    {
        printl("For "+spawnEnt);
        myScore = 0.0;
        foreach (otherPlayer in players)
        {
            if (player == otherPlayer)
                continue;
            local eyePos = otherPlayer.EyePosition();
            local spawnEyeLoc = spawnEnt.GetOrigin() + Vector(0, 0, 64);
            local distance = (eyePos - spawnEyeLoc).Length();
            if (distance < 100)
                distance = 0;
            local isVisible = TraceLine(eyePos, spawnEyeLoc, null) > 0.98;

            myScore += distance * (isVisible ? 0.3 : 1);
        }
        printl("  Total Score "+myScore);
        if (myScore >= maxScore)
        {
            maxScore = myScore;
            maxScoreSpawn = spawnEnt.GetOrigin();
        }

        spawnEnt.KeyValueFromString("targetname", "asd "+myScore)
    }
    printl("maxScore=" + maxScore);
    printl("maxScoreSpawn=" + maxScoreSpawn);
    printl(format("time taken= %.6f", (Time() - time)));
    return maxScoreSpawn;
}
//AddTimer(0.5, CalcSpawnScores)